#include <iostream>
#include "main.h"
using namespace std;

int main(){

	hls::stream<AXI_DMA_IO> in("in");
	hls::stream<AXI_DMA_IO> out("out");
	int a, b, c;
	a = 2;
	b = 3;

	cout << "initial stream in" << endl;
	AXI_DMA_IO temp;
	for (int i = 0; i < IN0_ROW; i++){
		for (int j = 0; j < IN0_COL; j++){
			temp.data = i+ j +1;
			if(i==IN0_ROW-1 && j==IN0_COL-1) temp.last = 1;
			else temp.last = 0;
			in.write(temp);
			cout << temp.data << " ";
		}
		cout << endl;
	}

	Hls_accel(in, out, a, b, c);
	ap_uint<16> res[IN1_ROW][IN1_COL][IN1_CH];

	cout << "finial stream out" << endl;
	for (int i = 0; i < IN1_ROW; i++){
		for (int j = 0; j < IN1_COL; j++){
			temp = out.read();
			res[i][j][0] = temp.data.range(15,0);
			res[i][j][1] = temp.data.range(31,16);
			res[i][j][2] = temp.data.range(47,32);
			res[i][j][3] = temp.data.range(63,48);
			cout << temp.last << endl;
		}
	}
	for (int c = 0; c < IN1_CH; c++){
		cout << "channel num:" << c << endl;
		for (int i = 0; i < IN1_ROW; i++){
			for (int j = 0; j < IN1_COL; j++){
				cout << res[i][j][c] << " ";
			}
			cout << endl;
		}
	}


	//std::cout << a << b << c;
}
