#pragma once
//#ifndef FUNCTION_H
//#define FUNCTION_H

//#define _DEBUG_

#include "main.h"
#include "ap_int.h"
using namespace hls;
#ifdef _DEBUG_
	using namespace std;
#endif
template <	unsigned IN_ROW,
			unsigned IN_COL,
			unsigned IN_CH,
			unsigned BW
		>
void strm_image(hls::stream<AXI_DMA_IO> &stream_in, hls::stream<ap_uint<IN_CH*BW> > &in){
	AXI_DMA_IO tmp;
//	static_assert(sizeof(tmp.data)==sizeof(ap_int<IN_CH*BW>),"DMA width != img_in width");
	for (int i = 0; i < IN_ROW*IN_COL; i++){
#pragma HLS PIPELINE
		tmp = stream_in.read();
		in.write(tmp.data);
	}
}

template <	unsigned IN_ROW,
			unsigned IN_COL,
			unsigned IN_CH,
			unsigned BW
		>
void strm_out(hls::stream<ap_uint<IN_CH*BW> > & img_out, hls::stream<AXI_DMA_IO>& stream_out){
	AXI_DMA_IO tmp;
//	static_assert(sizeof(tmp.data)==sizeof(ap_int<IN_CH*BW>),"DMA width != img_in width");
	for (int i = 0; i < IN_ROW*IN_COL; i++){
#pragma HLS PIPELINE
		tmp.data = img_out.read();
		if(i == IN_ROW*IN_COL -1)
			tmp.last = 1;
		else
			tmp.last = 0;
		stream_out.write(tmp);
	}

}


//#endif
