#include "main.h"
#include "function.h"


void Hls_accel(hls::stream<AXI_DMA_IO> &stream_in, hls::stream<AXI_DMA_IO> &stream_out,
		int a, int b, int &c){
#pragma HLS INTERFACE s_axilite register port=return
//#pragma HLS INTERFACE ap_ctrl_none port=return
#pragma HLS INTERFACE s_axilite port=b
#pragma HLS INTERFACE s_axilite port=a
#pragma HLS INTERFACE s_axilite port=c
#pragma HLS INTERFACE axis register both port=stream_in
#pragma HLS INTERFACE axis register both port=stream_out

c = a + b;

#pragma HLS DATAFLOW
stream<ap_uint<IN0_CH*ACT_BW_D> > img_in("img_in_stream");
strm_image<IN0_ROW,IN0_COL,IN0_CH,ACT_BW_D>(stream_in, img_in);
strm_out<IN0_ROW, IN0_COL, IN0_CH, ACT_BW_D>(img_in, stream_out);

}
